# coding: utf-8

"""
    Ambient API

     This API provides access to Ambient services. It is designed to be used by Ambient applications and services. 

    The version of the OpenAPI document: 0.8.2
    Contact: jose@ambientlabscomputing.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ambient_backend_api_client.models.grant_type import GrantType
from ambient_backend_api_client.models.token_request_type import TokenRequestType
from typing import Optional, Set
from typing_extensions import Self

class TokenRequest(BaseModel):
    """
    TokenRequest
    """ # noqa: E501
    grant_type: GrantType = Field(description="The type of token request")
    duration: Optional[StrictInt] = Field(default=3600, description="The duration of the token in seconds")
    token_description: Optional[StrictStr] = None
    request_type: TokenRequestType = Field(description="The type of token request (node or api)")
    access_token: Optional[StrictStr] = None
    refresh_token: Optional[StrictStr] = None
    node_id: Optional[StrictInt] = None
    device_code: Optional[StrictStr] = None
    user_code: Optional[StrictStr] = None
    client_id: Optional[StrictStr] = None
    client_secret: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["grant_type", "duration", "token_description", "request_type", "access_token", "refresh_token", "node_id", "device_code", "user_code", "client_id", "client_secret"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TokenRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if token_description (nullable) is None
        # and model_fields_set contains the field
        if self.token_description is None and "token_description" in self.model_fields_set:
            _dict['token_description'] = None

        # set to None if access_token (nullable) is None
        # and model_fields_set contains the field
        if self.access_token is None and "access_token" in self.model_fields_set:
            _dict['access_token'] = None

        # set to None if refresh_token (nullable) is None
        # and model_fields_set contains the field
        if self.refresh_token is None and "refresh_token" in self.model_fields_set:
            _dict['refresh_token'] = None

        # set to None if node_id (nullable) is None
        # and model_fields_set contains the field
        if self.node_id is None and "node_id" in self.model_fields_set:
            _dict['node_id'] = None

        # set to None if device_code (nullable) is None
        # and model_fields_set contains the field
        if self.device_code is None and "device_code" in self.model_fields_set:
            _dict['device_code'] = None

        # set to None if user_code (nullable) is None
        # and model_fields_set contains the field
        if self.user_code is None and "user_code" in self.model_fields_set:
            _dict['user_code'] = None

        # set to None if client_id (nullable) is None
        # and model_fields_set contains the field
        if self.client_id is None and "client_id" in self.model_fields_set:
            _dict['client_id'] = None

        # set to None if client_secret (nullable) is None
        # and model_fields_set contains the field
        if self.client_secret is None and "client_secret" in self.model_fields_set:
            _dict['client_secret'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TokenRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "grant_type": obj.get("grant_type"),
            "duration": obj.get("duration") if obj.get("duration") is not None else 3600,
            "token_description": obj.get("token_description"),
            "request_type": obj.get("request_type"),
            "access_token": obj.get("access_token"),
            "refresh_token": obj.get("refresh_token"),
            "node_id": obj.get("node_id"),
            "device_code": obj.get("device_code"),
            "user_code": obj.get("user_code"),
            "client_id": obj.get("client_id"),
            "client_secret": obj.get("client_secret")
        })
        return _obj


